; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    DwHds       PROTO :DWORD, :DWORD
    dw2hex_xx   PROTO :DWORD, :DWORD
    dword2hex1  PROTO :DWORD, :DWORD

    MakeHexChar macro reg:req, pos:req
      LOCAL lbl
        cmp reg, "9"
        jbe lbl
        add reg, 7
      lbl:
        mov byte ptr [eax + pos], reg
    endm


    .data
      align 16
        hex_table \
          db "000102030405060708090A0B0C0D0E0F"
          db "101112131415161718191A1B1C1D1E1F"
          db "202122232425262728292A2B2C2D2E2F"
          db "303132333435363738393A3B3C3D3E3F"
          db "404142434445464748494A4B4C4D4E4F"
          db "505152535455565758595A5B5C5D5E5F"
          db "606162636465666768696A6B6C6D6E6F"
          db "707172737475767778797A7B7C7D7E7F"
          db "808182838485868788898A8B8C8D8E8F"
          db "909192939495969798999A9B9C9D9E9F"
          db "A0A1A2A3A4A5A6A7A8A9AAABACADAEAF"
          db "B0B1B2B3B4B5B6B7B8B9BABBBCBDBEBF"
          db "C0C1C2C3C4C5C6C7C8C9CACBCCCDCECF"
          db "D0D1D2D3D4D5D6D7D8D9DADBDCDDDEDF"
          db "E0E1E2E3E4E5E6E7E8E9EAEBECEDEEEF"
          db "F0F1F2F3F4F5F6F7F8F9FAFBFCFDFEFF"

          h1 dd 12345678h
          h2 dd 98765432h
          h3 dd 0A1B2C3D4h
          h4 dd 0F9E8D7C6h
          h5 dd 0A7B3CCDDh
          h6 dd 01029ABCDh
          h7 dd 9876FEDCh
          h8 dd 04810EADCh

      icnt equ <25000000>

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    LOCAL pbuf  :DWORD
    LOCAL buffer[32]:BYTE

    LOCAL lcnt  :DWORD
    LOCAL hcnt  :DWORD
    LOCAL bcnt  :DWORD

    mov lcnt, 0
    mov hcnt, 0
    mov bcnt, 0

    mov pbuf, ptr$(buffer)

    sas pbuf,"xxxxxxxxxxxxxxxxxxxx"

    push esi


    invoke SetPriorityClass,rv(GetCurrentProcess),REALTIME_PRIORITY_CLASS


    REPEAT 8

; ----------------------------------

    mov esi, icnt
    invoke GetTickCount
    push eax

  @@:
    invoke dw2hex_xx,ADDR h1,pbuf
    invoke dw2hex_xx,ADDR h2,pbuf
    invoke dw2hex_xx,ADDR h3,pbuf
    invoke dw2hex_xx,ADDR h4,pbuf
    invoke dw2hex_xx,ADDR h5,pbuf
    invoke dw2hex_xx,ADDR h6,pbuf
    invoke dw2hex_xx,ADDR h7,pbuf
    invoke dw2hex_xx,ADDR h8,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    add hcnt, eax

    print str$(eax)," hutch",13,10

    invoke SleepEx,250,0

; ----------------------------------

    mov esi, icnt

    invoke GetTickCount
    push eax

  @@:
    invoke DwHds ,pbuf,ADDR h1
    invoke DwHds ,pbuf,ADDR h2
    invoke DwHds ,pbuf,ADDR h3
    invoke DwHds ,pbuf,ADDR h4
    invoke DwHds ,pbuf,ADDR h5
    invoke DwHds ,pbuf,ADDR h6
    invoke DwHds ,pbuf,ADDR h7
    invoke DwHds ,pbuf,ADDR h8
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx

    add lcnt, eax

    print str$(eax)," lingo",13,10

    invoke SleepEx,250,0

; ----------------------------------

 ;     mov esi, icnt
 ; 
 ;     invoke GetTickCount
 ;     push eax
 ; 
 ;   @@:
 ;     invoke dword2hex1,pbuf,ADDR h1
 ;     invoke dword2hex1,pbuf,ADDR h2
 ;     invoke dword2hex1,pbuf,ADDR h3
 ;     invoke dword2hex1,pbuf,ADDR h4
 ;     invoke dword2hex1,pbuf,ADDR h5
 ;     invoke dword2hex1,pbuf,ADDR h6
 ;     invoke dword2hex1,pbuf,ADDR h7
 ;     invoke dword2hex1,pbuf,ADDR h8
 ;     sub esi, 1
 ;     jnz @B
 ; 
 ;     invoke GetTickCount
 ;     pop ecx
 ;     sub eax, ecx
 ; 
 ;     add bcnt, eax
 ; 
 ;     print str$(eax)," BiteRider",13,10
 ; 
 ;     invoke SleepEx,250,0

; ----------------------------------

    ENDM

    invoke SetPriorityClass,rv(GetCurrentProcess),NORMAL_PRIORITY_CLASS

    print "-------",13,10
    print "Results",13,10
    print "-------",13,10

    mov eax, hcnt
    shr eax, 3
    print str$(eax)," hutch average",13,10

    mov eax, lcnt
    shr eax, 3
    print str$(eax)," lingo average",13,10

 ;     mov eax, bcnt
 ;     shr eax, 3
 ;     print str$(eax)," BiteRider average",13,10,13,10

    pop esi

    ret

main endp

; 
   
comment * Dword2Hex by lingo *
OPTION PROLOGUE:none
OPTION EPILOGUE:none
Align 16
DwHds proc lBuf2:dword, lValue:dword
    mov    eax,  [esp+8]                ; edx->offset of  MyValue
    movzx  ecx, byte ptr [eax]
    movzx  ecx, word ptr [hex_table+ecx+ecx]
    movzx  edx, byte ptr [eax+1]
    shl    ecx,16
    mov    cx, word ptr [hex_table+edx+edx]
    mov    edx, [esp+4]                 ; edx->lp of  MyBuffer
    mov    [edx+4], ecx
    movzx  ecx, byte ptr [eax+2]
    mov    byte ptr [edx+8], 0          ; end of string 
    movzx  ecx, word ptr [hex_table+ecx+ecx]
    movzx  eax, byte ptr [eax+3]
    shl    ecx, 16
    mov    cx, word ptr [hex_table+eax+eax]
    mov    [edx], ecx
    ret    8
DwHds      endp 
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

align 16

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

dw2hex_xx proc src:DWORD,buf:DWORD

    movzx ecx, BYTE PTR [esp+4]
    mov edx, DWORD PTR [ecx+ecx+hex_table]
    mov eax, [esp+8]                        ; load buffer address
    shl edx, 16
    movzx ecx, BYTE PTR [esp+5]
    mov dx, WORD PTR [ecx+ecx+hex_table]

    movzx ecx, BYTE PTR [esp+6]
    mov [eax+4], edx                        ; write 2nd DWORD
    mov ecx, DWORD PTR [ecx+ecx+hex_table]
    movzx edx, BYTE PTR [esp+7]
    shl ecx, 16
    mov cx, WORD PTR [edx+edx+hex_table]
    xor edx, edx
    mov [eax], ecx                          ; write 1st DWORD

    mov BYTE PTR [eax+8], dl

    ret 8

dw2hex_xx endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

comment 		* Dword2Hex1 *
align 		16
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
dword2hex1	proc pBuffe:DWORD, MyVal1:DWORD
   mov edx, [esp + 8]
   mov ecx, edx
   mov eax, [esp + 4]
   shr edx, 4
   and ecx, 0F0F0F0Fh
   and edx, 0F0F0F0Fh
   add ecx, "0000"
   mov byte ptr [eax + 8], 0
   add edx, "0000"
   
   MakeHexChar cl, 7
   MakeHexChar dl, 6
   MakeHexChar ch, 5
   shr ecx, 16
   MakeHexChar dh, 4
   MakeHexChar cl, 3
   shr edx, 16
   MakeHexChar dl, 2
   MakeHexChar ch, 1
   MakeHexChar dh, 0
   ret 8
dword2hex1 endp
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

end start
